<?php # $Id: serendipity_event_xmlrpc.php,v 1.23 2006/12/01 09:00:51 garvinhicking Exp $


if (IN_serendipity !== true) {
    die ("Don't hack!");
}

// Probe for a language include with constants. Still include defines later on, if some constants were missing
$probelang = dirname(__FILE__) . '/' . $serendipity['charset'] . 'lang_' . $serendipity['lang'] . '.inc.php';
if (file_exists($probelang)) {
    include $probelang;
}

include_once dirname(__FILE__) . '/lang_en.inc.php';

class serendipity_event_smtp extends serendipity_event
{
    var $title = PLUGIN_EVENT_SMTP_NAME;

    function introspect(&$propbag)
    {
        global $serendipity;

        $propbag->add('name',          PLUGIN_EVENT_SMTP_NAME);
        $propbag->add('description',   PLUGIN_EVENT_SMTP_DESC);
        $propbag->add('stackable',     false);
        $propbag->add('author',        'noone');
        $propbag->add('version',       '1.0');
        $propbag->add('requirements',  array(
            'serendipity' => '0.8',
            'smarty'      => '2.6.7',
            'php'         => '4.1.0'
        ));
        $propbag->add('event_hooks',    array(
            'backend_sendmail'  => true
        ));
        $propbag->add('groups', array('FRONTEND_FULL_MODS', 'FRONTEND_EXTERNAL_SERVICES'));
    }

    function generate_content(&$title) {
        $title = $this->title;
    }

    function event_hook($event, &$bag, &$eventData) {
        global $serendipity, $HTTP_RAW_POST_DATA;
           $hooks = &$bag->get('event_hooks');

        if (isset($hooks[$event])) {
            switch($event) {
                case 'backend_sendmail':
					if (!class_exists('Net_SMTP')) {
						require_once dirname(__FILE__) . '/PEAR/Net/SMTP.php';
					}
 				    $host = 'smtp_server';
					$from = $eventData['blogMail'];
					$rcpt = $eventData['to'];
					$subj = "Subject: " . $eventData['subject'] ."\n";
                    if (function_exists('mb_encode_mimeheader')) {
			            $subj = str_replace(array("\n", "\r"), array('', ''), mb_encode_mimeheader($eventData['subject'], LANG_CHARSET));
			        }
			        $body = $eventData['message'];
			        $maildata['headers'] = $eventData['headers'];
			        $maildata['headers'][] = 'Reply-To: "'. $eventData['fromName'] .'" <'. $eventData['fromMail'] .'>';
			        $maildata['headers'][] = 'X-Mailer: ' . $eventData['version'];
			        $maildata['headers'][] = 'X-Engine: PHP/'. phpversion();
			        $maildata['headers'][] = 'Message-ID: <'. md5(microtime() . uniqid(time())) .'@'. $_SERVER['HTTP_HOST'] .'>';
			        $maildata['headers'][] = 'MIME-Version: 1.0';
			        $maildata['headers'][] = 'Precedence: bulk';
			        $maildata['headers'][] = 'Content-Type: text/plain; charset=' . LANG_CHARSET;			        
                    if (LANG_CHARSET == 'UTF-8') {
			            if (function_exists('imap_8bit')) {
			            	$maildata['headers'][] = 'Content-Transfer-Encoding: quoted-printable';
			                $body   = str_replace("=\r\n", "", imap_8bit($eventData['message']));
			            } else {
			            	$maildata['headers'][] = 'Content-Transfer-Encoding: base64';
			                $body  = chunk_split(base64_encode($eventData['message']));
			            }
			        }
					
					
					if (! ($smtp = new Net_SMTP($host))) {
					    return false;
					}

					if (PEAR::isError($e = $smtp->connect())) {
					    return false;
					}
					$erg=$smtp->auth("user","pw");
					if (PEAR::isError($smtp->mailFrom($from))) {
					    return false;
					}					
				    if (PEAR::isError($res = $smtp->rcptTo($rcpt))) {
				        return false;
				    }
					if (PEAR::isError($smtp->data(implode("\n", $maildata['headers']) . "\r\n" . $subj . "\r\n" . $body))) {
						return false;
					}
					$smtp->disconnect();
                    return true;
                    break;

                default:
                    return false;
            }
        } else {
            return false;
        }
}
}
